import { Component } from '@angular/core';
import { NavController, Loading, LoadingController, MenuController } from 'ionic-angular';
import { ToolsProvider } from '../../providers/tools-provider';
import { LoginPage } from '../../pages/login/login';
import { HomePage } from '../../pages/home/home';

@Component({
    selector: 'page-hall',
    templateUrl: 'hall.html'
})
export class HallPage {

    loader: Loading;

    constructor(
        public navCtrl: NavController,
        public menuCtrl: MenuController,
        public loaderCtrl: LoadingController,
        public toolsProvider: ToolsProvider
    ) { }

    /**
     *
     */
    ionViewDidLoad() {
        console.log('Hello Hall Page');
        
        this.loader = this.loaderCtrl.create({
            content: "Configurando aplicación, espere..."
        });
        
        this.loader.present();

        this.toolsProvider.initializeDatabase().then(r => { 
            this.loader.dismiss();
            this.goToHome();
        }).catch(e => {
            console.log(e);
            this.loader.dismiss();
            
            this.goToLogin();
        });
    }

    /**
     * Go to login
     */
    private goToLogin(): void {
        this.navCtrl.setRoot(LoginPage);
    }

    /**
     * Go to home
     */
    private goToHome(): void {
        this.navCtrl.setRoot(HomePage);
        this.menuCtrl.enable(true);
    }
}
