import { Injectable } from '@angular/core';
import { DataProvider } from './data-provider';
import { OdooProvider } from './odoo-provider';
import { NetworkProvider } from './network-provider'

@Injectable()    
export class SyncProvider {

    constructor(
        public dataProvider: DataProvider,
        public odooProvider: OdooProvider
    ) { }

    /**
     *
     */
    doSync(): Promise<any> {
        return new Promise((resolve, reject) => {
            this.getCreatedProducts().then(products => {
                if (products.length == 0) {
                    resolve();
                }
                
                this.odooProvider.post("products", products).then(r => { 
                    resolve(r);
                }).catch(e => {
                    reject(e);
                });
            });            
        });
    }

    /**
     *
     */
    private pushCreatedProducts(): any {
        this.getCreatedProducts().then(p => {
            let promises = this.odooProvider.post("products", p);
            
            console.log(promises);
            
        }).catch(e => {
            console.log(e);
        });
    }

    /**
     *
     */
    private getCreatedProducts(): Promise<any> {
        return new Promise((resolve, reject) => {
            this.dataProvider.getAll("product").then(r => {
                resolve(r.products.filter(item => {
                    return item.doc_state === "created";
                }));
            }).catch(e => {
                reject(e);
            });
        });
    }

    /**
     *
     */
    private getUpdatedProducts(): Promise<any> {
        return new Promise((resolve, reject) => {
            this.dataProvider.getAll("product").then(r => { 
                resolve(r.products.filter(item => {
                    return item.doc_state === "updated" && item.remote_id != 0;
                }));
            }).catch(e => {
                reject(e);
            });
        });
    }

    /**
     *
     */
    private getDeletedProducts(): Promise<any> {
        return new Promise((resolve, reject) => { 
            this.dataProvider.getAll("product").then(r => { 
                resolve(r.products.filter(item => {
                    return item.doc_state === "deleted";
                }));
            }).catch(e => { 
                reject(e);
            });
        });
    }
}